]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
make.sh: Simplify maths to determine cursor position
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
f7a48dd3 20# Copyright (C) 2007-2017 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
33513817 27VERSION="2.19" # Version number
bb3272da 28CORE="117" # Core Level (Filename)
4f248f7a 29PAKFIRE_CORE="116" # Core Level (PAKFIRE)
595e89a8 30GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
e8ee3199
AF
31SLOGAN="www.ipfire.org" # Software slogan
32CONFIG_ROOT=/var/ipfire # Configuration rootdir
33NICE=10 # Nice level
34MAX_RETRIES=1 # prefetch/check loop
305a7b38 35BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 36KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
e8ee3199
AF
37GIT_TAG=$(git tag | tail -1) # Git Tag
38GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
628e8c3a 39
6c4cc7ea 40TOOLCHAINVER=20171121
03ad5f93 41
69a6ec55
MT
42###############################################################################
43#
44# Beautifying variables & presentation & input output interface
45#
46###############################################################################
47
f9783277
MT
48# Remember if the shell is interactive or not
49if [ -t 0 ] && [ -t 1 ]; then
50 INTERACTIVE=true
51else
52 INTERACTIVE=false
53fi
54
401a1edc
MT
55# Sets or adjusts pretty formatting variables
56resize_terminal() {
57 ## Screen Dimentions
58 # Find current screen size
59 COLUMNS=$(tput cols)
60
61 # When using remote connections, such as a serial port, stty size returns 0
62 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
63 COLUMNS=80
64 fi
69a6ec55 65
401a1edc
MT
66 # Measurements for positioning result messages
67 OPTIONS_WIDTH=20
68 TIME_WIDTH=12
69 STATUS_WIDTH=8
70 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
71 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
72
e9a57acd
MT
73 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
74 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 75}
69a6ec55 76
401a1edc
MT
77# Initially setup terminal
78resize_terminal
f9783277 79
401a1edc
MT
80# Call resize_terminal when terminal is being resized
81trap "resize_terminal" WINCH
69a6ec55
MT
82
83# Define color for messages
84BOLD="\\033[1;39m"
85DONE="\\033[1;32m"
86SKIP="\\033[1;34m"
87WARN="\\033[1;35m"
88FAIL="\\033[1;31m"
89NORMAL="\\033[0;39m"
90
bcb9dc13 91# New architecture variables
dc7d6b20 92HOST_ARCH="$(uname -m)"
94571564 93
69a6ec55
MT
94PWD=$(pwd)
95BASENAME=$(basename $0)
96
15679d9f
MT
97# Debian specific settings
98if [ ! -e /etc/debian_version ]; then
df5e82b3 99 FULLPATH=`which $0`
15679d9f 100else
df5e82b3
MT
101 if [ -x /usr/bin/realpath ]; then
102 FULLPATH=`/usr/bin/realpath $0`
103 else
104 echo "ERROR: Need to do apt-get install realpath"
105 exit 1
106 fi
15679d9f 107fi
df5e82b3 108
69a6ec55 109# This is the directory where make.sh is in
aecbe123 110export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 111
15679d9f 112LOGFILE=$BASEDIR/log/_build.preparation.log
aecbe123 113export LOGFILE
15679d9f
MT
114DIR_CHK=$BASEDIR/cache/check
115mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 116
69a6ec55
MT
117system_processors() {
118 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
119}
120
121system_memory() {
122 local key val unit
123
124 while read -r key val unit; do
125 case "${key}" in
126 MemTotal:*)
127 # Convert to MB
128 echo "$(( ${val} / 1024 ))"
129 break
130 ;;
131 esac
132 done < /proc/meminfo
133}
134
135configure_build() {
136 local build_arch="${1}"
137
138 if [ "${build_arch}" = "default" ]; then
139 build_arch="$(configure_build_guess)"
140 fi
141
142 case "${build_arch}" in
143 x86_64)
144 BUILDTARGET="${build_arch}-unknown-linux-gnu"
145 CROSSTARGET="${build_arch}-cross-linux-gnu"
146 BUILD_PLATFORM="x86"
147 CFLAGS_ARCH="-m64 -mtune=generic"
148 ;;
149
150 i586)
151 BUILDTARGET="${build_arch}-pc-linux-gnu"
152 CROSSTARGET="${build_arch}-cross-linux-gnu"
153 BUILD_PLATFORM="x86"
154 CFLAGS_ARCH="-march=i586 -mtune=generic -fomit-frame-pointer"
155 ;;
156
157 aarch64)
158 BUILDTARGET="${build_arch}-unknown-linux-gnu"
159 CROSSTARGET="${build_arch}-cross-linux-gnu"
160 BUILD_PLATFORM="arm"
161 CFLAGS_ARCH=""
162 ;;
163
164 armv7hl)
165 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
166 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
167 BUILD_PLATFORM="arm"
168 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
169 ;;
170
171 armv5tel)
172 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
173 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
174 BUILD_PLATFORM="arm"
175 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
176 ;;
177
178 *)
179 exiterror "Cannot build for architure ${build_arch}"
180 ;;
181 esac
182
183 # Check if the QEMU helper is available if needed.
184 if qemu_is_required "${build_arch}"; then
185 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
186
187 if [ -n "${qemu_build_helper}" ]; then
188 QEMU_TARGET_HELPER="${qemu_build_helper}"
189 else
190 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
191 fi
192 fi
193
194 BUILD_ARCH="${build_arch}"
195 TOOLS_DIR="/tools_${BUILD_ARCH}"
196
197 # Enables hardening
198 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -fstack-protector-strong --param=ssp-buffer-size=4"
199
200 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
201 CXXFLAGS="${CFLAGS}"
202
203 # Determine parallelism
204 if [ -z "${MAKETUNING}" ]; then
205 # We assume that each process consumes about
206 # 192MB of memory. Therefore we find out how
207 # many processes fit into memory.
208 local mem_max=$(( ${HOST_MEM} / 192 ))
209
210 local processors="$(system_processors)"
211 local cpu_max=$(( ${processors} * 2 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
220 MAKETUNING="-j${parallelism}"
221 fi
222}
223
224configure_build_guess() {
225 case "${HOST_ARCH}" in
226 x86_64|i686|i586)
227 echo "i586"
228 ;;
229
230 aarch64)
231 echo "aarch64"
232 ;;
233
234 armv7*|armv6*|armv5*)
235 echo "armv5tel"
236 ;;
237
238 *)
239 exiterror "Cannot guess build architecture"
240 ;;
241 esac
242}
243
f9783277
MT
244stdumount() {
245 umount $BASEDIR/build/sys 2>/dev/null;
246 umount $BASEDIR/build/dev/shm 2>/dev/null;
247 umount $BASEDIR/build/dev/pts 2>/dev/null;
248 umount $BASEDIR/build/dev 2>/dev/null;
249 umount $BASEDIR/build/proc 2>/dev/null;
250 umount $BASEDIR/build/install/mnt 2>/dev/null;
251 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
252 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
253 umount $BASEDIR/build/usr/src/config 2>/dev/null;
254 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
255 umount $BASEDIR/build/usr/src/html 2>/dev/null;
256 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
257 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
258 umount $BASEDIR/build/usr/src/log 2>/dev/null;
259 umount $BASEDIR/build/usr/src/src 2>/dev/null;
260}
261
262now() {
263 date -u "+%s"
69a6ec55
MT
264}
265
f9783277
MT
266format_runtime() {
267 local seconds=${1}
268
269 if [ ${seconds} -ge 3600 ]; then
270 printf "%d:%02d:%02d\n" \
271 "$(( seconds / 3600 ))" \
272 "$(( seconds % 3600 / 60 ))" \
273 "$(( seconds % 3600 % 60 ))"
274 elif [ ${seconds} -ge 60 ]; then
275 printf "%d:%02d\n" \
276 "$(( seconds / 60 ))" \
277 "$(( seconds % 60 ))"
69a6ec55 278 else
f9783277 279 printf "%d\n" "${seconds}"
69a6ec55 280 fi
f9783277 281}
69a6ec55 282
f9783277
MT
283print_line() {
284 local line="$@"
69a6ec55 285
f9783277 286 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
287}
288
f9783277
MT
289_print_line() {
290 local status="${1}"
291 shift
69a6ec55 292
f9783277
MT
293 if ${INTERACTIVE}; then
294 printf "${!status}"
295 fi
69a6ec55 296
f9783277
MT
297 print_line "$@"
298
299 if ${INTERACTIVE}; then
300 printf "${NORMAL}"
301 fi
302}
303
304print_headline() {
305 _print_line BOLD "$@"
69a6ec55
MT
306}
307
f9783277
MT
308print_error() {
309 _print_line FAIL "$@"
310}
311
312print_package() {
313 local name="${1}"
314 shift
69a6ec55 315
f9783277
MT
316 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
317 local options="$@"
318
319 local string="${name}"
320 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
321 string="${string} (${version})"
322 fi
323
324 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 325 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
326}
327
328print_runtime() {
329 local runtime=$(format_runtime $@)
330
331 if ${INTERACTIVE}; then
332 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
333 else
334 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 335 fi
f9783277
MT
336}
337
338print_status() {
339 local status="${1}"
340
341 local color="${!status}"
342
343 if ${INTERACTIVE}; then
344 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
345 else
346 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 347 fi
f9783277 348}
69a6ec55 349
f9783277
MT
350print_build_stage() {
351 print_headline "$@"
352
353 # end line
354 printf "\n"
69a6ec55
MT
355}
356
f9783277
MT
357print_build_summary() {
358 local runtime=$(format_runtime $@)
359
360 print_line "*** Build finished in ${runtime}"
361 print_status DONE
69a6ec55
MT
362}
363
364exiterror() {
365 stdumount
366 for i in `seq 0 7`; do
367 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
368 losetup -d /dev/loop${i} 2>/dev/null
369 fi;
370 done
371
f9783277 372 # Dump logfile
66028310 373 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
374 echo # empty line
375
376 local line
377 while read -r line; do
378 echo " ${line}"
379 done <<< "$(tail -n30 ${LOGFILE})"
380 fi
381
f9783277
MT
382 echo # empty line
383
384 local line
385 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
386 print_error "${line}"
387 print_status FAIL
388 done
389
69a6ec55
MT
390 exit 1
391}
392
aecbe123
MT
393prepareenv() {
394 # Are we running the right shell?
54328605 395 if [ -z "${BASH}" ]; then
aecbe123
MT
396 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
397 fi
398
399 if [ -z "${BASH_VERSION}" ]; then
400 exiterror "Not running BASH shell."
401 fi
402
403 # Trap on emergency exit
404 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
405
406 # Resetting our nice level
658232a6 407 if ! renice ${NICE} $$ >/dev/null; then
658232a6 408 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
409 fi
410
411 # Checking if running as root user
658232a6 412 if [ $(id -u) -ne 0 ]; then
aecbe123 413 exiterror "Not building as root"
aecbe123
MT
414 fi
415
416 # Checking for necessary temporary space
f9783277 417 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
418 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
419 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
420 if (( 2048000 > $BASE_ASPACE )); then
421 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
422 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 423 print_status FAIL
aecbe123
MT
424 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
425 fi
426 else
f9783277 427 print_status DONE
aecbe123
MT
428 fi
429
430 # Set umask
431 umask 022
432
433 # Set LFS Directory
434 LFS=$BASEDIR/build
435
436 # Check ${TOOLS_DIR} symlink
437 if [ -h "${TOOLS_DIR}" ]; then
438 rm -f "${TOOLS_DIR}"
439 fi
440
441 if [ ! -e "${TOOLS_DIR}" ]; then
442 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
443 fi
444
445 if [ ! -h "${TOOLS_DIR}" ]; then
446 exiterror "Could not create ${TOOLS_DIR} symbolic link"
447 fi
448
449 # Setup environment
450 set +h
451 LC_ALL=POSIX
452 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
453 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
454
455 # Make some extra directories
456 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
457 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
458 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
459 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
460 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
461
462 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
463 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
464
465 # Make all sources and proc available under lfs build
466 mount --bind /dev $BASEDIR/build/dev
467 mount --bind /dev/pts $BASEDIR/build/dev/pts
468 mount --bind /dev/shm $BASEDIR/build/dev/shm
469 mount --bind /proc $BASEDIR/build/proc
470 mount --bind /sys $BASEDIR/build/sys
471 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
472 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
473 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
474 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
475 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
476 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
477 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
478 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
479 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
480
481 # Run LFS static binary creation scripts one by one
482 export CCACHE_DIR=$BASEDIR/ccache
483 export CCACHE_COMPRESS=1
484 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
485
486 # Remove pre-install list of installed files in case user erase some files before rebuild
487 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
488
489 # Prepare string for /etc/system-release.
490 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
491 if [ "$(git status -s | wc -l)" == "0" ]; then
492 GIT_STATUS=""
493 else
494 GIT_STATUS="-dirty"
495 fi
496 case "$GIT_BRANCH" in
497 core*|beta?|rc?)
498 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
499 ;;
500 *)
501 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
502 ;;
503 esac
504}
505
69a6ec55
MT
506enterchroot() {
507 # Install QEMU helper, if needed
508 qemu_install_helper
509
510 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
511
512 PATH="${PATH}" chroot ${LFS} env -i \
513 HOME="/root" \
514 TERM="${TERM}" \
515 PS1="${PS1}" \
516 PATH="${PATH}" \
517 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
518 PAKFIRE_CORE="${PAKFIRE_CORE}" \
519 NAME="${NAME}" \
520 SNAME="${SNAME}" \
521 VERSION="${VERSION}" \
522 CORE="${CORE}" \
523 SLOGAN="${SLOGAN}" \
524 TOOLS_DIR="${TOOLS_DIR}" \
525 CONFIG_ROOT="${CONFIG_ROOT}" \
526 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
527 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
528 BUILDTARGET="${BUILDTARGET}" \
529 CROSSTARGET="${CROSSTARGET}" \
530 BUILD_ARCH="${BUILD_ARCH}" \
531 BUILD_PLATFORM="${BUILD_PLATFORM}" \
532 CCACHE_DIR=/usr/src/ccache \
533 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
534 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
535 KVER="${KVER}" \
536 $(fake_environ) \
537 $(qemu_environ) \
538 "$@"
539}
540
541entershell() {
542 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
543 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
544 fi
545
546 echo "Entering to a shell inside LFS chroot, go out with exit"
547 local PS1="ipfire build chroot ($(uname -m)) \u:\w\$ "
548
549 if enterchroot bash -i; then
550 stdumount
551 else
f9783277 552 print_status FAIL
69a6ec55
MT
553 exiterror "chroot error"
554 fi
555}
556
557lfsmakecommoncheck() {
558 # Script present?
559 if [ ! -f $BASEDIR/lfs/$1 ]; then
560 exiterror "No such file or directory: $BASEDIR/$1"
561 fi
562
f9783277
MT
563 # Print package name and version
564 print_package $@
69a6ec55
MT
565
566 # Check if this package is supported by our architecture.
567 # If no SUP_ARCH is found, we assume the package can be built for all.
568 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
569 # Check if package supports ${BUILD_ARCH} or all architectures.
570 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 571 print_runtime 0
f9783277 572 print_status SKIP
69a6ec55
MT
573 return 1
574 fi
575 fi
576
577 # Script slipped?
578 local i
579 for i in $SKIP_PACKAGE_LIST
580 do
581 if [ "$i" == "$1" ]; then
f9783277 582 print_status SKIP
69a6ec55
MT
583 return 1;
584 fi
585 done
586
587 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
588
589 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
590 MESSAGE="$1\t " download >> $LOGFILE 2>&1
591 if [ $? -ne 0 ]; then
592 exiterror "Download error in $1"
593 fi
594
595 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
596 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
597 if [ $? -ne 0 ]; then
598 exiterror "md5sum error in $1, check file in cache or signature"
599 fi
600
601 return 0 # pass all!
602}
603
604lfsmake1() {
605 lfsmakecommoncheck $*
606 [ $? == 1 ] && return 0
607
69a6ec55
MT
608 cd $BASEDIR/lfs && env -i \
609 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
610 CCACHE_DIR="${CCACHE_DIR}" \
611 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
612 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
613 CFLAGS="${CFLAGS}" \
614 CXXFLAGS="${CXXFLAGS}" \
615 MAKETUNING="${MAKETUNING}" \
616 make -f $* \
617 TOOLCHAIN=1 \
618 TOOLS_DIR="${TOOLS_DIR}" \
619 CROSSTARGET="${CROSSTARGET}" \
620 BUILDTARGET="${BUILDTARGET}" \
621 BUILD_ARCH="${BUILD_ARCH}" \
622 BUILD_PLATFORM="${BUILD_PLATFORM}" \
623 LFS_BASEDIR="${BASEDIR}" \
624 ROOT="${LFS}" \
625 KVER="${KVER}" \
f9783277 626 install >> $LOGFILE 2>&1 &
69a6ec55 627
f9783277
MT
628 if ! wait_until_finished $!; then
629 print_status FAIL
630 exiterror "Building $*"
69a6ec55
MT
631 fi
632
f9783277 633 print_status DONE
69a6ec55
MT
634}
635
636lfsmake2() {
637 lfsmakecommoncheck $*
638 [ $? == 1 ] && return 0
639
69a6ec55
MT
640 local PS1='\u:\w$ '
641
642 enterchroot \
643 bash -x -c "cd /usr/src/lfs && \
644 MAKETUNING=${MAKETUNING} \
645 make -f $* \
646 LFS_BASEDIR=/usr/src install" \
f9783277 647 >> ${LOGFILE} 2>&1 &
69a6ec55 648
f9783277
MT
649 if ! wait_until_finished $!; then
650 print_status FAIL
651 exiterror "Building $*"
69a6ec55
MT
652 fi
653
f9783277 654 print_status DONE
69a6ec55
MT
655}
656
657ipfiredist() {
658 lfsmakecommoncheck $*
659 [ $? == 1 ] && return 0
660
69a6ec55
MT
661 local PS1='\u:\w$ '
662
663 enterchroot \
664 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 665 >> ${LOGFILE} 2>&1 &
69a6ec55 666
f9783277
MT
667 if ! wait_until_finished $!; then
668 print_status FAIL
669 exiterror "Packaging $*"
670 fi
69a6ec55 671
f9783277
MT
672 print_status DONE
673}
674
675wait_until_finished() {
676 local pid=${1}
677
678 local start_time=$(now)
679
680 # Show progress
681 if ${INTERACTIVE}; then
682 # Wait a little just in case the process
683 # has finished very quickly.
684 sleep 0.1
685
686 local runtime
687 while kill -0 ${pid} 2>/dev/null; do
688 print_runtime $(( $(now) - ${start_time} ))
689
690 # Wait a little
691 sleep 1
692 done
69a6ec55 693 fi
f9783277
MT
694
695 # Returns the exit code of the child process
696 wait ${pid}
697 local ret=$?
698
699 if ! ${INTERACTIVE}; then
700 print_runtime $(( $(now) - ${start_time} ))
701 fi
702
703 return ${ret}
69a6ec55
MT
704}
705
706fake_environ() {
707 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
708
709 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
710
711 # Fake kernel version, because some of the packages do not compile
712 # with kernel 3.0 and later.
713 env="${env} UTS_RELEASE=${KVER}"
714
715 # Fake machine version.
716 env="${env} UTS_MACHINE=${BUILD_ARCH}"
717
718 echo "${env}"
719}
720
721qemu_environ() {
722 local env
723
724 # Don't add anything if qemu is not used.
725 if ! qemu_is_required; then
726 return
727 fi
728
729 # Set default qemu options
730 case "${BUILD_ARCH}" in
731 arm*)
732 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
733
734 env="${env} QEMU_CPU=${QEMU_CPU}"
735 ;;
736 esac
737
738 # Enable QEMU strace
739 #env="${env} QEMU_STRACE=1"
740
741 echo "${env}"
742}
743
744qemu_is_required() {
745 local build_arch="${1}"
746
747 if [ -z "${build_arch}" ]; then
748 build_arch="${BUILD_ARCH}"
749 fi
750
751 case "${HOST_ARCH},${build_arch}" in
752 x86_64,arm*|i?86,arm*|i?86,x86_64)
753 return 0
754 ;;
755 *)
756 return 1
757 ;;
758 esac
759}
760
761qemu_install_helper() {
762 # Do nothing, if qemu is not required
763 if ! qemu_is_required; then
764 return 0
765 fi
766
767 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
768 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
769 fi
770
771 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
772 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
773 fi
774
775
776 if [ -z "${QEMU_TARGET_HELPER}" ]; then
777 exiterror "QEMU_TARGET_HELPER not set"
778 fi
779
780 # Check if the helper is already installed.
781 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
782 return 0
783 fi
784
785 # Try to find a suitable binary that we can install
786 # to the build environment.
787 local file
788 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
789 # file must exist and be executable.
790 [ -x "${file}" ] || continue
791
792 # Must be static.
793 file_is_static "${file}" || continue
794
795 local dirname="${LFS}$(dirname "${file}")"
796 mkdir -p "${dirname}"
797
798 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
799 return 0
800 done
801
802 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
803}
804
805qemu_find_build_helper_name() {
806 local build_arch="${1}"
807
808 local magic
809 case "${build_arch}" in
810 arm*)
811 magic="7f454c4601010100000000000000000002002800"
812 ;;
813 x86_64)
814 magic="7f454c4602010100000000000000000002003e00"
815 ;;
816 esac
817
818 [ -z "${magic}" ] && return 1
819
820 local file
821 for file in /proc/sys/fs/binfmt_misc/*; do
822 # skip write only register entry
823 [ $(basename "${file}") = "register" ] && continue
824 # Search for the file with the correct magic value.
825 grep -qE "^magic ${magic}$" "${file}" || continue
826
827 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
828
829 [ -n "${interpreter}" ] || continue
830 [ "${interpreter:0:1}" = "/" ] || continue
831 [ -x "${interpreter}" ] || continue
832
833 echo "${interpreter}"
834 return 0
835 done
836
837 return 1
838}
839
840file_is_static() {
841 local file="${1}"
842
843 file ${file} 2>/dev/null | grep -q "statically linked"
844}
845
846update_language_list() {
847 local path="${1}"
848
849 local lang
850 for lang in ${path}/*.po; do
851 lang="$(basename "${lang}")"
852 echo "${lang%*.po}"
853 done | sort -u > "${path}/LINGUAS"
854}
855
a98ab1d7
MT
856# Load configuration file
857if [ -f .config ]; then
858 . .config
859fi
860
813659f2
MT
861# TARGET_ARCH is BUILD_ARCH now
862if [ -n "${TARGET_ARCH}" ]; then
863 BUILD_ARCH="${TARGET_ARCH}"
864 unset TARGET_ARCH
865fi
866
5190eea2
MT
867# Get the amount of memory in this build system
868HOST_MEM=$(system_memory)
869
dc7d6b20
MT
870if [ -n "${BUILD_ARCH}" ]; then
871 configure_build "${BUILD_ARCH}"
949544f5 872else
dc7d6b20 873 configure_build "default"
949544f5
MT
874fi
875
df5e82b3 876buildtoolchain() {
69a6ec55
MT
877 local error=false
878 case "${BUILD_ARCH}:${HOST_ARCH}" in
879 # x86_64
880 x86_64:x86_64)
881 # This is working.
882 ;;
883
884 # x86
885 i586:i586|i586:i686|i586:x86_64)
886 # These are working.
887 ;;
888 i586:*)
889 error=true
890 ;;
891
892 # ARM
893 arvm7hl:armv7hl|armv7hl:armv7l)
894 # These are working.
895 ;;
896
897 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
898 # These are working.
899 ;;
900 armv5tel:*)
901 error=true
902 ;;
903 esac
904
905 ${error} && \
906 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
907
908 local gcc=$(type -p gcc)
909 if [ -z "${gcc}" ]; then
910 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
911 fi
912
913 LOGFILE="$BASEDIR/log/_build.toolchain.log"
914 export LOGFILE
915
916 lfsmake1 stage1
917 lfsmake1 ccache PASS=1
918 lfsmake1 binutils PASS=1
919 lfsmake1 gcc PASS=1
920 lfsmake1 linux KCFG="-headers"
921 lfsmake1 glibc
922 lfsmake1 gcc PASS=L
923 lfsmake1 binutils PASS=2
924 lfsmake1 gcc PASS=2
925 lfsmake1 ccache PASS=2
926 lfsmake1 tcl
927 lfsmake1 expect
928 lfsmake1 dejagnu
929 lfsmake1 pkg-config
930 lfsmake1 ncurses
931 lfsmake1 bash
932 lfsmake1 bzip2
933 lfsmake1 automake
934 lfsmake1 coreutils
935 lfsmake1 diffutils
936 lfsmake1 findutils
937 lfsmake1 gawk
938 lfsmake1 gettext
939 lfsmake1 grep
940 lfsmake1 gzip
941 lfsmake1 m4
942 lfsmake1 make
943 lfsmake1 patch
944 lfsmake1 perl
945 lfsmake1 sed
946 lfsmake1 tar
947 lfsmake1 texinfo
948 lfsmake1 xz
949 lfsmake1 fake-environ
950 lfsmake1 cleanup-toolchain
df5e82b3
MT
951}
952
953buildbase() {
69a6ec55
MT
954 LOGFILE="$BASEDIR/log/_build.base.log"
955 export LOGFILE
956 lfsmake2 stage2
957 lfsmake2 linux KCFG="-headers"
958 lfsmake2 man-pages
959 lfsmake2 glibc
960 lfsmake2 tzdata
961 lfsmake2 cleanup-toolchain
962 lfsmake2 zlib
963 lfsmake2 binutils
964 lfsmake2 gmp
965 lfsmake2 gmp-compat
966 lfsmake2 mpfr
967 lfsmake2 libmpc
968 lfsmake2 file
969 lfsmake2 gcc
970 lfsmake2 sed
971 lfsmake2 autoconf
972 lfsmake2 automake
973 lfsmake2 berkeley
974 lfsmake2 coreutils
975 lfsmake2 iana-etc
976 lfsmake2 m4
977 lfsmake2 bison
978 lfsmake2 ncurses-compat
979 lfsmake2 ncurses
980 lfsmake2 procps
981 lfsmake2 libtool
982 lfsmake2 perl
983 lfsmake2 readline
984 lfsmake2 readline-compat
985 lfsmake2 bzip2
986 lfsmake2 pcre
987 lfsmake2 pcre-compat
988 lfsmake2 bash
989 lfsmake2 diffutils
990 lfsmake2 e2fsprogs
991 lfsmake2 ed
992 lfsmake2 findutils
993 lfsmake2 flex
994 lfsmake2 gawk
995 lfsmake2 gettext
996 lfsmake2 grep
997 lfsmake2 groff
998 lfsmake2 gperf
999 lfsmake2 gzip
1000 lfsmake2 hostname
1001 lfsmake2 iproute2
1002 lfsmake2 jwhois
1003 lfsmake2 kbd
1004 lfsmake2 less
1005 lfsmake2 make
1006 lfsmake2 man
1007 lfsmake2 kmod
1008 lfsmake2 net-tools
1009 lfsmake2 patch
1010 lfsmake2 psmisc
1011 lfsmake2 shadow
1012 lfsmake2 sysklogd
1013 lfsmake2 sysvinit
1014 lfsmake2 tar
1015 lfsmake2 texinfo
1016 lfsmake2 util-linux
1017 lfsmake2 udev
1018 lfsmake2 vim
1019 lfsmake2 xz
1020 lfsmake2 paxctl
df5e82b3
MT
1021}
1022
15679d9f 1023buildipfire() {
907cd036 1024 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1025 export LOGFILE
489145db
MT
1026 lfsmake2 configroot
1027 lfsmake2 initscripts
1028 lfsmake2 backup
1029 lfsmake2 pkg-config
1030 lfsmake2 libusb
1031 lfsmake2 libusb-compat
1032 lfsmake2 libpcap
1033 lfsmake2 ppp
1034 lfsmake2 pptp
1035 lfsmake2 unzip
1036 lfsmake2 which
1037 lfsmake2 linux-firmware
1038 lfsmake2 ath10k-firmware
1039 lfsmake2 dvb-firmwares
1040 lfsmake2 mt7601u-firmware
1041 lfsmake2 zd1211-firmware
1042 lfsmake2 rpi-firmware
1043 lfsmake2 bc
1044 lfsmake2 u-boot
1045 lfsmake2 cpio
1046 lfsmake2 mdadm
1047 lfsmake2 dracut
1048 lfsmake2 lvm2
1049 lfsmake2 multipath-tools
1050 lfsmake2 freetype
1051 lfsmake2 grub
1052 lfsmake2 libmnl
1053 lfsmake2 libnfnetlink
1054 lfsmake2 libnetfilter_queue
1055 lfsmake2 libnetfilter_conntrack
1056 lfsmake2 libnetfilter_cthelper
1057 lfsmake2 libnetfilter_cttimeout
1058 lfsmake2 iptables
8e6fb99d 1059
dc7d6b20 1060 case "${BUILD_ARCH}" in
fc155193 1061 x86_64)
489145db
MT
1062 lfsmake2 linux KCFG=""
1063 lfsmake2 backports KCFG=""
1064 lfsmake2 e1000e KCFG=""
1065 lfsmake2 igb KCFG=""
1066 lfsmake2 ixgbe KCFG=""
1067 lfsmake2 xtables-addons KCFG=""
1068 lfsmake2 linux-initrd KCFG=""
fc155193 1069 ;;
3d02c091
MT
1070 i586)
1071 # x86-pae (Native and new XEN) kernel build
489145db
MT
1072 lfsmake2 linux KCFG="-pae"
1073 lfsmake2 backports KCFG="-pae"
1074 lfsmake2 e1000e KCFG="-pae"
1075 lfsmake2 igb KCFG="-pae"
1076 lfsmake2 ixgbe KCFG="-pae"
1077 lfsmake2 xtables-addons KCFG="-pae"
1078 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1079
1080 # x86 kernel build
489145db
MT
1081 lfsmake2 linux KCFG=""
1082 lfsmake2 backports KCFG=""
1083 lfsmake2 e1000e KCFG=""
1084 lfsmake2 igb KCFG=""
1085 lfsmake2 ixgbe KCFG=""
1086 lfsmake2 xtables-addons KCFG=""
1087 lfsmake2 linux-initrd KCFG=""
3d02c091 1088 ;;
544f40d4 1089
3d02c091
MT
1090 armv5tel)
1091 # arm-rpi (Raspberry Pi) kernel build
489145db
MT
1092 lfsmake2 linux KCFG="-rpi"
1093 lfsmake2 backports KCFG="-rpi"
1094 lfsmake2 xtables-addons KCFG="-rpi"
1095 lfsmake2 linux-initrd KCFG="-rpi"
3d02c091
MT
1096
1097 # arm multi platform (Panda, Wandboard ...) kernel build
489145db
MT
1098 lfsmake2 linux KCFG="-multi"
1099 lfsmake2 backports KCFG="-multi"
1100 lfsmake2 e1000e KCFG="-multi"
1101 lfsmake2 igb KCFG="-multi"
1102 lfsmake2 ixgbe KCFG="-multi"
1103 lfsmake2 xtables-addons KCFG="-multi"
1104 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1105
1106 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
489145db
MT
1107 lfsmake2 linux KCFG="-kirkwood"
1108 lfsmake2 backports KCFG="-kirkwood"
1109 lfsmake2 e1000e KCFG="-kirkwood"
1110 lfsmake2 igb KCFG="-kirkwood"
1111 lfsmake2 ixgbe KCFG="-kirkwood"
1112 lfsmake2 xtables-addons KCFG="-kirkwood"
1113 lfsmake2 linux-initrd KCFG="-kirkwood"
3d02c091
MT
1114 ;;
1115 esac
489145db
MT
1116 lfsmake2 xtables-addons USPACE="1"
1117 lfsmake2 openssl
1118 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1119 lfsmake2 libgpg-error
1120 lfsmake2 libgcrypt
1121 lfsmake2 libassuan
1122 lfsmake2 nettle
1123 lfsmake2 libevent
1124 lfsmake2 libevent2
89ad036a 1125 lfsmake2 libevent2-compat
489145db 1126 lfsmake2 expat
c8e9a7a8
WA
1127 lfsmake2 apr
1128 lfsmake2 aprutil
489145db
MT
1129 lfsmake2 unbound
1130 lfsmake2 gnutls
1131 lfsmake2 bind
1132 lfsmake2 dhcp
1133 lfsmake2 dhcpcd
1134 lfsmake2 boost
1135 lfsmake2 linux-atm
1136 lfsmake2 gdbm
1137 lfsmake2 pam
1138 lfsmake2 curl
1139 lfsmake2 tcl
1140 lfsmake2 sqlite
1141 lfsmake2 libffi
1142 lfsmake2 python
1143 lfsmake2 python3
1144 lfsmake2 ca-certificates
1145 lfsmake2 fireinfo
1146 lfsmake2 libnet
1147 lfsmake2 libnl
1148 lfsmake2 libnl-3
1149 lfsmake2 libidn
1150 lfsmake2 nasm
1151 lfsmake2 libjpeg
1152 lfsmake2 libjpeg-compat
1153 lfsmake2 libexif
1154 lfsmake2 libpng
1155 lfsmake2 libtiff
1156 lfsmake2 libart
1157 lfsmake2 gd
1158 lfsmake2 popt
489145db
MT
1159 lfsmake2 slang
1160 lfsmake2 newt
1161 lfsmake2 libsmooth
1162 lfsmake2 attr
1163 lfsmake2 acl
1164 lfsmake2 libcap
1165 lfsmake2 pciutils
1166 lfsmake2 usbutils
1167 lfsmake2 libxml2
1168 lfsmake2 libxslt
1169 lfsmake2 BerkeleyDB
1170 lfsmake2 mysql
1171 lfsmake2 cyrus-sasl
1172 lfsmake2 openldap
1173 lfsmake2 apache2
1174 lfsmake2 php
1175 lfsmake2 web-user-interface
1176 lfsmake2 flag-icons
1177 lfsmake2 jquery
6033b271 1178 lfsmake2 bootstrap
489145db
MT
1179 lfsmake2 arping
1180 lfsmake2 beep
1181 lfsmake2 dvdrtools
1182 lfsmake2 dosfstools
1183 lfsmake2 reiserfsprogs
1184 lfsmake2 xfsprogs
1185 lfsmake2 sysfsutils
1186 lfsmake2 fuse
1187 lfsmake2 ntfs-3g
1188 lfsmake2 ethtool
1189 lfsmake2 ez-ipupdate
1190 lfsmake2 fcron
1191 lfsmake2 perl-GD
1192 lfsmake2 GD-Graph
1193 lfsmake2 GD-TextUtil
1194 lfsmake2 perl-Device-SerialPort
1195 lfsmake2 perl-Device-Modem
1196 lfsmake2 perl-Apache-Htpasswd
1197 lfsmake2 gnupg
1198 lfsmake2 hdparm
1199 lfsmake2 sdparm
1200 lfsmake2 mtools
1201 lfsmake2 whatmask
1202 lfsmake2 conntrack-tools
1203 lfsmake2 libupnp
1204 lfsmake2 ipaddr
1205 lfsmake2 iputils
1206 lfsmake2 l7-protocols
1207 lfsmake2 mISDNuser
1208 lfsmake2 capi4k-utils
1209 lfsmake2 hwdata
1210 lfsmake2 logrotate
1211 lfsmake2 logwatch
1212 lfsmake2 misc-progs
1213 lfsmake2 nano
1214 lfsmake2 URI
1215 lfsmake2 HTML-Tagset
1216 lfsmake2 HTML-Parser
1217 lfsmake2 HTML-Template
1218 lfsmake2 Compress-Zlib
1219 lfsmake2 Digest
1220 lfsmake2 Digest-SHA1
1221 lfsmake2 Digest-HMAC
1222 lfsmake2 libwww-perl
1223 lfsmake2 Net-DNS
1224 lfsmake2 Net-IPv4Addr
1225 lfsmake2 Net_SSLeay
1226 lfsmake2 IO-Stringy
1227 lfsmake2 IO-Socket-SSL
1228 lfsmake2 Unix-Syslog
1229 lfsmake2 Mail-Tools
1230 lfsmake2 MIME-Tools
1231 lfsmake2 Net-Server
1232 lfsmake2 Convert-TNEF
1233 lfsmake2 Convert-UUlib
1234 lfsmake2 Archive-Tar
1235 lfsmake2 Archive-Zip
1236 lfsmake2 Text-Tabs+Wrap
1237 lfsmake2 Locale-Country
1238 lfsmake2 XML-Parser
1239 lfsmake2 Crypt-PasswdMD5
1240 lfsmake2 Net-Telnet
1241 lfsmake2 python-setuptools
1242 lfsmake2 python-clientform
1243 lfsmake2 python-mechanize
1244 lfsmake2 python-feedparser
1245 lfsmake2 python-rssdler
1246 lfsmake2 python-inotify
1247 lfsmake2 python-docutils
1248 lfsmake2 python-daemon
1249 lfsmake2 python-ipaddress
1250 lfsmake2 glib
1251 lfsmake2 GeoIP
489145db
MT
1252 lfsmake2 noip_updater
1253 lfsmake2 ntp
1254 lfsmake2 openssh
1255 lfsmake2 fontconfig
1256 lfsmake2 dejavu-fonts-ttf
70f6cba4 1257 lfsmake2 ubuntu-font-family
489145db
MT
1258 lfsmake2 freefont
1259 lfsmake2 pixman
1260 lfsmake2 cairo
1261 lfsmake2 pango
1262 lfsmake2 rrdtool
1263 lfsmake2 setserial
1264 lfsmake2 setup
1265 lfsmake2 libdnet
1266 lfsmake2 daq
1267 lfsmake2 snort
1268 lfsmake2 oinkmaster
1269 lfsmake2 squid
1270 lfsmake2 squidguard
1271 lfsmake2 calamaris
1272 lfsmake2 tcpdump
1273 lfsmake2 traceroute
1274 lfsmake2 vlan
1275 lfsmake2 wireless
1276 lfsmake2 pakfire
1277 lfsmake2 spandsp
1278 lfsmake2 lzo
1279 lfsmake2 openvpn
1280 lfsmake2 pammysql
1281 lfsmake2 mpage
1282 lfsmake2 dbus
1283 lfsmake2 intltool
1284 lfsmake2 libdaemon
1285 lfsmake2 cups
489145db 1286 lfsmake2 lcms2
56170c2a 1287 lfsmake2 ghostscript
489145db
MT
1288 lfsmake2 qpdf
1289 lfsmake2 poppler
1290 lfsmake2 cups-filters
1291 lfsmake2 epson-inkjet-printer-escpr
1292 lfsmake2 foomatic
1293 lfsmake2 hplip
1294 lfsmake2 cifs-utils
1295 lfsmake2 krb5
1296 lfsmake2 samba
1297 lfsmake2 sudo
1298 lfsmake2 mc
1299 lfsmake2 wget
1300 lfsmake2 bridge-utils
1301 lfsmake2 screen
1302 lfsmake2 smartmontools
1303 lfsmake2 htop
1304 lfsmake2 chkconfig
1305 lfsmake2 postfix
1306 lfsmake2 fetchmail
1307 lfsmake2 cyrus-imapd
1308 lfsmake2 openmailadmin
1309 lfsmake2 clamav
1310 lfsmake2 spamassassin
1311 lfsmake2 amavisd
1312 lfsmake2 dma
1313 lfsmake2 alsa
1314 lfsmake2 mpfire
1315 lfsmake2 guardian
1316 lfsmake2 libid3tag
1317 lfsmake2 libmad
1318 lfsmake2 libogg
1319 lfsmake2 libvorbis
1320 lfsmake2 libdvbpsi
1321 lfsmake2 flac
1322 lfsmake2 lame
1323 lfsmake2 sox
1324 lfsmake2 libshout
1325 lfsmake2 xvid
1326 lfsmake2 libmpeg2
1327 lfsmake2 libarchive
1328 lfsmake2 cmake
1329 lfsmake2 gnump3d
1330 lfsmake2 rsync
1331 lfsmake2 tcpwrapper
1332 lfsmake2 libtirpc
1333 lfsmake2 rpcbind
1334 lfsmake2 nfs
1335 lfsmake2 gnu-netcat
1336 lfsmake2 ncat
1337 lfsmake2 nmap
489145db
MT
1338 lfsmake2 etherwake
1339 lfsmake2 bwm-ng
1340 lfsmake2 sysstat
489145db
MT
1341 lfsmake2 strongswan
1342 lfsmake2 rng-tools
1343 lfsmake2 lsof
1344 lfsmake2 br2684ctl
1345 lfsmake2 pcmciautils
1346 lfsmake2 lm_sensors
1347 lfsmake2 liboping
1348 lfsmake2 collectd
1349 lfsmake2 elinks
1350 lfsmake2 igmpproxy
1351 lfsmake2 fbset
1352 lfsmake2 opus
1353 lfsmake2 python-six
1354 lfsmake2 python-pyparsing
1355 lfsmake2 spice-protocol
1356 lfsmake2 spice
1357 lfsmake2 sdl
1358 lfsmake2 libusbredir
1359 lfsmake2 qemu
1360 lfsmake2 sane
1361 lfsmake2 netpbm
1362 lfsmake2 phpSANE
1363 lfsmake2 tunctl
1364 lfsmake2 netsnmpd
1365 lfsmake2 nagios
1366 lfsmake2 nagios_nrpe
1367 lfsmake2 icinga
1368 lfsmake2 ebtables
1369 lfsmake2 directfb
489145db
MT
1370 lfsmake2 faad2
1371 lfsmake2 ffmpeg
1372 lfsmake2 vdr
1373 lfsmake2 vdr_streamdev
489145db
MT
1374 lfsmake2 vdr_epgsearch
1375 lfsmake2 vdr_dvbapi
1376 lfsmake2 vdr_eepg
1377 lfsmake2 w_scan
1378 lfsmake2 icecast
1379 lfsmake2 icegenerator
1380 lfsmake2 mpd
1381 lfsmake2 libmpdclient
1382 lfsmake2 mpc
1383 lfsmake2 perl-Net-SMTP-SSL
1384 lfsmake2 perl-MIME-Base64
1385 lfsmake2 perl-Authen-SASL
1386 lfsmake2 perl-MIME-Lite
1387 lfsmake2 perl-Email-Date-Format
1388 lfsmake2 git
1389 lfsmake2 squidclamav
1390 lfsmake2 vnstat
1391 lfsmake2 iw
1392 lfsmake2 wpa_supplicant
1393 lfsmake2 hostapd
1394 lfsmake2 pycurl
1395 lfsmake2 urlgrabber
1396 lfsmake2 syslinux
1397 lfsmake2 tftpd
1398 lfsmake2 cpufrequtils
1399 lfsmake2 bluetooth
1400 lfsmake2 gutenprint
1401 lfsmake2 apcupsd
1402 lfsmake2 iperf
1403 lfsmake2 iperf3
1404 lfsmake2 7zip
1405 lfsmake2 lynis
1406 lfsmake2 streamripper
1407 lfsmake2 sshfs
1408 lfsmake2 taglib
1409 #lfsmake2 mediatomb
1410 lfsmake2 sslh
1411 lfsmake2 perl-gettext
1412 lfsmake2 perl-Sort-Naturally
1413 lfsmake2 vdradmin
1414 lfsmake2 miau
1415 lfsmake2 perl-DBI
1416 lfsmake2 perl-DBD-mysql
1417 lfsmake2 perl-DBD-SQLite
1418 lfsmake2 perl-File-ReadBackwards
1419 lfsmake2 cacti
1420 lfsmake2 openvmtools
1421 lfsmake2 nagiosql
489145db
MT
1422 lfsmake2 motion
1423 lfsmake2 joe
1424 lfsmake2 monit
1425 lfsmake2 nut
1426 lfsmake2 watchdog
1427 lfsmake2 libpri
1428 lfsmake2 libsrtp
1429 lfsmake2 asterisk
1430 lfsmake2 lcr
1431 lfsmake2 usb_modeswitch
1432 lfsmake2 usb_modeswitch_data
1433 lfsmake2 zerofree
489145db
MT
1434 lfsmake2 minicom
1435 lfsmake2 ddrescue
489145db
MT
1436 lfsmake2 miniupnpd
1437 lfsmake2 client175
1438 lfsmake2 powertop
1439 lfsmake2 parted
1440 lfsmake2 swig
1441 lfsmake2 python-m2crypto
1442 lfsmake2 wireless-regdb
1443 lfsmake2 crda
1444 lfsmake2 libsolv
1445 lfsmake2 python-distutils-extra
1446 lfsmake2 python-lzma
1447 lfsmake2 python-progressbar
1448 lfsmake2 python-xattr
1449 lfsmake2 ddns
1450 lfsmake2 transmission
1451 lfsmake2 dpfhack
1452 lfsmake2 lcd4linux
1453 lfsmake2 mtr
489145db
MT
1454 lfsmake2 minidlna
1455 lfsmake2 acpid
1456 lfsmake2 fping
1457 lfsmake2 telnet
1458 lfsmake2 xinetd
1459 lfsmake2 gpgme
1460 lfsmake2 pygpgme
1461 lfsmake2 pakfire3
1462 lfsmake2 stress
1463 lfsmake2 libstatgrab
1464 lfsmake2 sarg
1465 lfsmake2 check_mk_agent
1466 lfsmake2 nginx
1467 lfsmake2 sendEmail
1468 lfsmake2 sysbench
1469 lfsmake2 strace
1470 lfsmake2 elfutils
1471 lfsmake2 ltrace
1472 lfsmake2 ipfire-netboot
1473 lfsmake2 lcdproc
1474 lfsmake2 bitstream
1475 lfsmake2 multicat
1476 lfsmake2 keepalived
1477 lfsmake2 ipvsadm
1478 lfsmake2 perl-Carp-Clan
1479 lfsmake2 perl-Date-Calc
1480 lfsmake2 perl-Date-Manip
1481 lfsmake2 perl-File-Tail
1482 lfsmake2 perl-TimeDate
1483 lfsmake2 swatch
1484 lfsmake2 tor
1485 lfsmake2 arm
1486 lfsmake2 wavemon
1487 lfsmake2 iptraf-ng
1488 lfsmake2 iotop
1489 lfsmake2 stunnel
489145db
MT
1490 lfsmake2 owncloud
1491 lfsmake2 bacula
1492 lfsmake2 batctl
b62c826f
MT
1493 lfsmake2 perl-Font-TTF
1494 lfsmake2 perl-IO-String
489145db
MT
1495 lfsmake2 perl-PDF-API2
1496 lfsmake2 squid-accounting
1497 lfsmake2 pigz
1498 lfsmake2 tmux
1499 lfsmake2 perl-Text-CSV_XS
1500 lfsmake2 swconfig
1501 lfsmake2 haproxy
1502 lfsmake2 ipset
1503 lfsmake2 lua
1504 lfsmake2 dnsdist
1505 lfsmake2 bird
1506 lfsmake2 dmidecode
1507 lfsmake2 mcelog
1508 lfsmake2 rtpproxy
1509 lfsmake2 util-macros
1510 lfsmake2 libpciaccess
1511 lfsmake2 libyajl
1512 lfsmake2 libvirt
b190cbe2 1513 lfsmake2 python3-libvirt
489145db
MT
1514 lfsmake2 freeradius
1515 lfsmake2 perl-common-sense
1516 lfsmake2 perl-inotify2
1517 lfsmake2 perl-Net-IP
0d6cc79d 1518 lfsmake2 wio
773caa66 1519 lfsmake2 iftop
d0817963 1520}
df5e82b3
MT
1521
1522buildinstaller() {
1523 # Run installer scripts one by one
1524 LOGFILE="$BASEDIR/log/_build.installer.log"
1525 export LOGFILE
489145db
MT
1526 lfsmake2 memtest
1527 lfsmake2 installer
4960c912 1528 lfsmake1 strip
df5e82b3
MT
1529}
1530
1531buildpackages() {
1532 LOGFILE="$BASEDIR/log/_build.packages.log"
1533 export LOGFILE
1534 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1535
df5e82b3
MT
1536
1537 # Generating list of packages used
dc4ae0b7 1538 print_line "Generating packages list from logs"
df5e82b3
MT
1539 rm -f $BASEDIR/doc/packages-list
1540 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1541 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1542 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1543 fi
1544 done
7471f6ab 1545 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1546 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1547 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1548 rm -f $BASEDIR/doc/packages-list
c9673262 1549 # packages-list.txt is ready to be displayed for wiki page
f9783277 1550 print_status DONE
4b06f504
MT
1551
1552 # Update changelog
e49f7f0d 1553 cd $BASEDIR
c43b07fd
AF
1554 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1555 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1556 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1557
9607771a 1558 # Create images for install
489145db 1559 lfsmake2 cdrom
bada0832 1560
4dc82852 1561 # Check if there is a loop device for building in virtual environments
841663e7
MT
1562 modprobe loop 2>/dev/null
1563 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db
MT
1564 lfsmake2 flash-images
1565 lfsmake2 flash-images SCON=1
4dc82852 1566 fi
c9673262 1567
f0fc8807 1568 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1569
0d909a4a 1570 ipfirepackages
e67a57fe 1571
489145db 1572 lfsmake2 xen-image
939c2a21 1573 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1574
b307417f 1575 cd $BASEDIR
744a04ea
AF
1576
1577 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1578 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1579
b307417f
AF
1580 for i in `ls *.bz2 *.img.gz *.iso`; do
1581 md5sum $i > $i.md5
1582 done
1583 cd $PWD
1584
e67a57fe
MT
1585 # Cleanup
1586 stdumount
1587 rm -rf $BASEDIR/build/tmp/*
1588
e67a57fe 1589 cd $PWD
e67a57fe
MT
1590}
1591
1592ipfirepackages() {
489145db 1593 lfsmake2 core-updates
5596077b
MT
1594
1595 local i
dc7d6b20 1596 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1597 i=$(basename ${i})
453b418b
MT
1598 if [ -e $BASEDIR/lfs/$i ]; then
1599 ipfiredist $i
1600 else
1601 echo -n $i
f9783277 1602 print_status SKIP
453b418b 1603 fi
fe7fe395 1604 done
78331e30 1605 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1606 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1607 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1608}
1609
bcb9dc13
MT
1610while [ $# -gt 0 ]; do
1611 case "${1}" in
1612 --target=*)
c2e810de 1613 configure_build "${1#--target=}"
bcb9dc13
MT
1614 ;;
1615 -*)
1616 exiterror "Unknown configuration option: ${1}"
1617 ;;
1618 *)
1619 # Found a command, so exit options parsing.
1620 break
1621 ;;
1622 esac
1623 shift
1624done
1625
df5e82b3
MT
1626# See what we're supposed to do
1627case "$1" in
1628build)
f9783277
MT
1629 START_TIME=$(now)
1630
1631 # Clear screen
1632 ${INTERACTIVE} && clear
1633
f74072a2 1634 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1635 #only restore on a clean disk
6c4cc7ea 1636 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1637 if [ ! -n "$PACKAGE" ]; then
f9783277 1638 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1639 prepareenv
1640 buildtoolchain
1641 else
f74072a2 1642 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1643 print_build_stage "Packaged toolchain compilation"
df5e82b3 1644 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1645 tar axf $PACKAGE
df5e82b3
MT
1646 prepareenv
1647 else
1648 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1649 fi
1650 fi
1651 else
df5e82b3
MT
1652 prepareenv
1653 fi
5cfe86e6 1654
f9783277 1655 print_build_stage "Building LFS"
df5e82b3 1656 buildbase
15679d9f 1657
f9783277 1658 print_build_stage "Building IPFire"
15679d9f 1659 buildipfire
5cfe86e6 1660
f9783277 1661 print_build_stage "Building installer"
df5e82b3 1662 buildinstaller
15679d9f 1663
f9783277 1664 print_build_stage "Building packages"
df5e82b3 1665 buildpackages
7a5ed24e 1666
f9783277 1667 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1668
1669 cd $BASEDIR
7a5ed24e 1670 tools/checknewlog.pl
e0c923f4 1671 tools/checkrootfiles
b307417f 1672 cd $PWD
a23731d1 1673
f9783277 1674 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1675 ;;
1676shell)
1677 # enter a shell inside LFS chroot
1678 # may be used to changed kernel settings
1679 prepareenv
1680 entershell
1681 ;;
df5e82b3 1682clean)
f9783277
MT
1683 print_line "Cleaning build directory..."
1684
df5e82b3
MT
1685 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1686 $LOSETUP -d $i 2>/dev/null
1687 done
1688 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1689 umount $i
1690 done
1691 stdumount
1692 for i in `seq 0 7`; do
69a6ec55 1693 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1694 umount /dev/loop${i} 2>/dev/null;
1695 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1696 fi;
df5e82b3
MT
1697 done
1698 rm -rf $BASEDIR/build
1699 rm -rf $BASEDIR/cdrom
f9315063 1700 rm -rf $BASEDIR/packages
df5e82b3 1701 rm -rf $BASEDIR/log
6c4cc7ea
MT
1702 if [ -h "${TOOLS_DIR}" ]; then
1703 rm -f "${TOOLS_DIR}"
df5e82b3 1704 fi
b307417f 1705 rm -f $BASEDIR/ipfire-*
f9783277 1706 print_status DONE
df5e82b3 1707 ;;
c3db995c 1708downloadsrc)
df5e82b3
MT
1709 if [ ! -d $BASEDIR/cache ]; then
1710 mkdir $BASEDIR/cache
1711 fi
1712 mkdir -p $BASEDIR/log
857d9bf2 1713 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1714 FINISHED=0
1715 cd $BASEDIR/lfs
1716 for c in `seq $MAX_RETRIES`; do
1717 if (( FINISHED==1 )); then
1718 break
1719 fi
1720 FINISHED=1
1721 cd $BASEDIR/lfs
1722 for i in *; do
1723 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1724 lfsmakecommoncheck ${i} || continue
1725
dc7d6b20 1726 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1727 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1728 if [ $? -ne 0 ]; then
f9783277 1729 print_status FAIL
df5e82b3
MT
1730 FINISHED=0
1731 else
1732 if [ $c -eq 1 ]; then
f9783277 1733 print_status DONE
df5e82b3
MT
1734 fi
1735 fi
1736 fi
1737 done
1738 done
e22c7973 1739 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1740 ERROR=0
1741 for i in *; do
1742 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1743 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1744 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1745 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1746 if [ $? -ne 0 ]; then
e22c7973 1747 echo -ne "MD5 difference in lfs/$i"
f9783277 1748 print_status FAIL
df5e82b3
MT
1749 ERROR=1
1750 fi
1751 fi
1752 done
1753 if [ $ERROR -eq 0 ]; then
e22c7973 1754 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1755 print_status DONE
e22c7973
MT
1756 else
1757 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1758 print_status FAIL
df5e82b3 1759 fi
e22c7973 1760 cd - >/dev/null 2>&1
df5e82b3 1761 ;;
df5e82b3 1762toolchain)
f9783277
MT
1763 # Clear screen
1764 ${INTERACTIVE} && clear
1765
df5e82b3 1766 prepareenv
f3b7cf47 1767 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1768 buildtoolchain
f74072a2 1769 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1770 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1771 cd $BASEDIR && XZ_OPT="-T0 -8" tar -Jc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
6c4cc7ea 1772 build/${TOOLS_DIR} build/bin/sh log >> $LOGFILE
f74072a2 1773 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1774 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1775 stdumount
1776 ;;
1777gettoolchain)
df5e82b3 1778 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1779 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1780 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1781 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1782 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1783 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1784 cd $BASEDIR/cache/toolchains
f74072a2 1785 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1786 if [ $? -ne 0 ]; then
dc7d6b20 1787 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1788 else
f74072a2 1789 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1790 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1791 else
1792 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1793 fi
40a4ea4c 1794 fi
712d859c
MT
1795 else
1796 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1797 fi
1798 ;;
15679d9f
MT
1799uploadsrc)
1800 PWD=`pwd`
661d9388
CS
1801 if [ -z $IPFIRE_USER ]; then
1802 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1803 print_status FAIL
661d9388
CS
1804 exit 1
1805 fi
ae23a606 1806
661d9388 1807 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1808 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1809
15e38431
MT
1810 for file in ${BASEDIR}/cache/*; do
1811 [ -d "${file}" ] && continue
1812 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1813 NEW_FILES="$NEW_FILES $file"
0eab8e84 1814 done
661d9388
CS
1815 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1816 cd $BASEDIR
15679d9f
MT
1817 cd $PWD
1818 exit 0
0eab8e84 1819 ;;
bf7c473f 1820lang)
69a6ec55
MT
1821 echo -ne "Checking the translations for missing or obsolete strings..."
1822 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1823 $BASEDIR/tools/sort_strings.pl en
1824 $BASEDIR/tools/sort_strings.pl de
1825 $BASEDIR/tools/sort_strings.pl fr
1826 $BASEDIR/tools/sort_strings.pl es
1827 $BASEDIR/tools/sort_strings.pl pl
1828 $BASEDIR/tools/sort_strings.pl ru
1829 $BASEDIR/tools/sort_strings.pl nl
1830 $BASEDIR/tools/sort_strings.pl tr
1831 $BASEDIR/tools/sort_strings.pl it
1832 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1833 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1834 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1835 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1836 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1837 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1838 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1839 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1840 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1841 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1842 print_status DONE
69a6ec55
MT
1843
1844 echo -ne "Updating language lists..."
1845 update_language_list ${BASEDIR}/src/installer/po
1846 update_language_list ${BASEDIR}/src/setup/po
f9783277 1847 print_status DONE
bf7c473f 1848 ;;
6b8cff41 1849*)
a50d04ab 1850 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1851 cat doc/make.sh-usage
1852 ;;
3ea75603 1853esac